// L-systems.  rock on!

// now with drums!

// axiom = A
// rule1 = A -> B
// rule2 = B -> BA

// midi stuff
import promidi.*;
MidiIO midiIO;
MidiOut midiOut;
Note note;
int position = 0;

// L-systems stuff
// set the number of generations
int generations = 5;

// what we're gonna start with
String axiom = "A";

// we need an array of rules
String[][] rules = {
  {
    "A", "ABC"
  },
  {
    "B", "CDCA"
  },
  {
    "C", "BA"
  }
};

String instring, outstring;

int i, j, k;
int ismatching = 0;


void setup()
{
  size(128, 128);
  frameRate(8);

  // do the MIDI setup stuff
  midiIO = MidiIO.getInstance(this);
  midiIO.printDevices();
  midiOut = midiIO.getMidiOut(9, 0); // channel 10 (i.e. 9) is the drum channel
  midiOut.sendProgramChange(
        new ProgramChange(0)
  );

  // run the L-system
  instring = axiom;
  println("axiom:" + axiom);

  for (i=0;i<generations;i++) // 1 - loop through the generations
  {
    outstring = "";
    for (j=0;j<instring.length();j++) // 2 - loop through the input string
    {
      ismatching = 0;
      for (k=0;k<rules.length;k++) // 3 - loop through the rules
      {
        if (instring.charAt(j)==rules[k][0].charAt(0)) ismatching++;
        if (ismatching>0) {
          outstring=outstring+rules[k][1];
          k = rules.length;
        }
      }
      if (ismatching==0)
      {
        outstring=outstring+instring.charAt(j);
      }
    }
    instring = outstring; // we know we're doing this at the end
    println(i + ": " + outstring);
  }
}

void draw()
{
  if(instring.charAt(position)=='A')
  {
    note = new Note(36, 100, 250);
    midiOut.sendNote(note);
  }
  if(instring.charAt(position)=='B')
  {
    note = new Note(38, 100, 250);
    midiOut.sendNote(note);
  }
  if(instring.charAt(position)=='C')
  {
    note = new Note(43, 100, 250);
    midiOut.sendNote(note);
  }
  if(instring.charAt(position)=='D')
  {
    note = new Note(70, 100, 250);
    midiOut.sendNote(note);
  }

  position++;
  if(position>=instring.length()) position=0;
}

void mousePressed()
{

  note = new Note(mouseX, mouseY, 1000);
  midiOut.sendNote(note);
}

