// hi there

post("hi there!\n");

var MAXSTACK = 50;
var lindenmat = new JitterMatrix(1, "char", 800);
lindenmat.adapt = 1;

var i, c;
var ox = 0;
var oy = 0;

var x = new Array(MAXSTACK);
var y = new Array(MAXSTACK);
var angle = new Array(MAXSTACK);

var step = 0.1;
var TWO_PI = 6.283185307179586;
var angleincr = 90;
var curstack=0;

reset();

function jit_matrix(v)
{
	var newx, newy;
	lindenmat.frommatrix(v);
	for(i=0;i<lindenmat.dim;i++)
	{
			c = String.fromCharCode(lindenmat.getcell(i));
			
			outlet(0, "beginstroke", "basic2d");
			outlet(0, "strokepoint", x[curstack], y[curstack]);

			if(c=="f") // move forward
			{
					newx = x[curstack]+(step*Math.cos(angle[curstack]/360.*TWO_PI));
					newy = y[curstack]+(step*Math.sin(angle[curstack]/360.*TWO_PI));
					x[curstack] = newx;
					y[curstack] = newy;
			}
			if(c=="F") // draw forward
			{
					newx = x[curstack]+(step*Math.cos(angle[curstack]/360.*TWO_PI));
					newy = y[curstack]+(step*Math.sin(angle[curstack]/360.*TWO_PI));
					outlet(0, "strokepoint", newx, newy);
					x[curstack] = newx;
					y[curstack] = newy;
			}
			if(c=="+") // turn right
			{
					angle[curstack] = (angle[curstack]+angleincr)%360.;
			}
			if(c=="-") // turn left
			{
					angle[curstack] = (angle[curstack]-angleincr)%360.;
			}
			if(c=="[") // push stack (branch begins)
			{
					curstack++;
					if(curstack<MAXSTACK) // draw
					{
						x[curstack] = x[curstack-1];
						y[curstack] = y[curstack-1];
						angle[curstack] = angle[curstack-1];
						outlet(0, "beginstroke", "basic2d");
						outlet(0, "strokepoint", x[curstack], y[curstack]);
					}
				
			}
			if(c=="]") // pop stack (branch end)
			{
					curstack--;
					if(curstack<0) {
						curstack=0;
					}
					outlet(0, "endstroke");
				
			}
			outlet(0, "endstroke");
		
	}
	
	
}

function setorigin(a, b)
{
		ox = a;
		oy = b;
}

function setangle(v)
{
		angleincr = v;
}

function setstep(v)
{
		step = v;
}

function reset()
{
	for(i=0;i<MAXSTACK;i++)
	{
		x[i] = ox;
		y[i] = oy;
		angle[i] = 0.;	
	}
	curstack = 0;
}